
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Booking_extrasDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const booking_extras = await db.booking_extras.create(
            {
                id: data.id || undefined,
        
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await booking_extras.setBooking( data.booking || null, {
            transaction,
        });
        
        await booking_extras.setExtra( data.extra || null, {
            transaction,
        });
        
        await booking_extras.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return booking_extras;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const booking_extrasData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const booking_extras = await db.booking_extras.bulkCreate(booking_extrasData, { transaction });

        // For each item created, replace relation files
        

        return booking_extras;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const booking_extras = await db.booking_extras.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        updatePayload.updatedById = currentUser.id;

        await booking_extras.update(updatePayload, {transaction});

        
        
        if (data.booking !== undefined) {
            await booking_extras.setBooking(
              
              data.booking,
              
              { transaction }
            );
        }
        
        if (data.extra !== undefined) {
            await booking_extras.setExtra(
              
              data.extra,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await booking_extras.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return booking_extras;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const booking_extras = await db.booking_extras.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of booking_extras) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of booking_extras) {
                await record.destroy({transaction});
            }
        });


        return booking_extras;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const booking_extras = await db.booking_extras.findByPk(id, options);

        await booking_extras.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await booking_extras.destroy({
            transaction
        });

        return booking_extras;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const booking_extras = await db.booking_extras.findOne(
            { where },
            { transaction },
        );

        if (!booking_extras) {
            return booking_extras;
        }

        const output = booking_extras.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.booking = await booking_extras.getBooking({
            transaction
        });
        
        
        output.extra = await booking_extras.getExtra({
            transaction
        });
        
        
        output.organizations = await booking_extras.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.bookings,
        as: 'booking',
        
        where: filter.booking ? {
          [Op.or]: [
            { id: { [Op.in]: filter.booking.split('|').map(term => Utils.uuid(term)) } },
            {
              internal_notes: {
                [Op.or]: filter.booking.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.extras,
        as: 'extra',
        
        where: filter.extra ? {
          [Op.or]: [
            { id: { [Op.in]: filter.extra.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.extra.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'booking_extras',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.booking_extras.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'booking_extras',
                        'currency',
                        query,
                    ),
                ],
            };
        }

        const records = await db.booking_extras.findAll({
            attributes: [ 'id', 'currency' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['currency', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.currency,
        }));
    }

    
};

